=== debian/changelog ===
f3d (1.2.1+dfsg-2) unstable; urgency=medium

  * Source only upload for migration to testing
  * Update metainfo copyright
  * Bump standard version to 4.6.0.1

 -- Francois Mazen <francois@mzf.fr>  Sun, 20 Feb 2022 16:49:12 +0100

f3d (1.2.1+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #985993)

 -- Francois Mazen <francois@mzf.fr>  Sat, 27 Mar 2021 13:08:02 +0100
