=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_TESTING:BOOL=OFF \
	-DBUILD_SHARED_LIBS=OFF \
	-DF3D_GENERATE_MAN=ON

override_dh_auto_install:
	dh_auto_install
	rm debian/f3d/usr/share/doc/f3d/LICENSE
