=== debian/tests/control ===
Test-Command: f3d --version
Depends: f3d
Restrictions: superficial

Test-Command: f3d --help
Depends: f3d
Restrictions: superficial

Tests: check-cube-vtp
Depends: f3d, xvfb, xauth
